#include <stdio.h>
#include <fcntl.h>
#include <termio.h>

static char r[2] = {0,0};

#define TTY0 "/dev/ttyS0"
#define TTY1 "/dev/ttyGS0"

int main(int ac, char **av)
{
        int fd0;
        int fd1;
        int len;
        struct termios tio;

        if ((fd0 = open(TTY0, O_RDWR)) < 0) {
                fprintf(stderr, "%s: open error\n", TTY0);
                exit(1);
        }
        if ((fd1 = open(TTY1, O_RDWR)) < 0) {
                fprintf(stderr, "%s: open error\n", TTY1);
                exit(1);
        }
        bzero(&tio, sizeof(tio));

        tio.c_cflag = B9600 | CS8 | CLOCAL | CREAD;
        tio.c_cc[VMIN] = 1;
        tcsetattr(fd0, TCSANOW, &tio);
        tcsetattr(fd1, TCSANOW, &tio);

        while(1) {
                len = read(fd0, r, 1);
                if (len > 0) {
                        write(fd1, r, 1);
                }
        }
        return 0;
}
